// written 2004 Mirko Roller   mirko@mirkoroller.de
// Example shows you how to read/write to SMC card


#include "gp32.h"
#include "fileio.h"


int main() {

  DIR dir_struct;
  int dir_entrys;
  int x;
  
  unsigned short *framebuffer1;
  framebuffer1 = (u16*) FRAMEBUFFER;
  gp_setCpuspeed(33);
  gp_initFramebuffer(framebuffer1,16,85);
  gp_clearFramebuffer16(framebuffer1,0xffff);
   
    // Reading Directory of \\gpmm
    dir_entrys=smc_dir("dev0:\\gpmm\\",&dir_struct);
    // dir_entrys==0 ERROR,    dir_entrys>0 OK
    
    // Display the first 7 dir entrys
    if (dir_entrys>7) dir_entrys=7;  
    for (x=0;x<dir_entrys;x++) { 
      char buffer1[80];
      char buffer2[20];
      sprintf (buffer1,"%d %s                    ",x,dir_struct.name[x]);
      sprintf (buffer2,"%d          ",dir_struct.size[x]);
      gp_drawString(10,10+(x*8),20,buffer1,0xF800,framebuffer1);
      gp_drawString(10+(15*8),10+(x*8),10,buffer2,0xF800>>5,framebuffer1);
    }
   
   // Loading something to memory
   { char *buffer;       // pointer to free memory
     int offset=0;       // position in file, 0=beginning
     int bytes=8192;     // read bytes
     int bytes_read;
     buffer = (char*) malloc(bytes);
     bytes_read=smc_read("dev0:\\GPMM\\SMCTEST.FXE",buffer,offset,bytes); 
     if (bytes_read == 0) gp_drawString(10,160,10,"ERROR      ",0xF800,framebuffer1);
     if (bytes_read == 8192) gp_drawString(10,160,25,"Reading of 8192 Bytes ok      ",0xF800,framebuffer1);
     if ( (buffer[0]==0x66) && (buffer[1]==0x78) && (buffer[2]==0x65) )  // fxe
        gp_drawString(10,170,12,"content ok      ",0xF800,framebuffer1);
   }  	

   // Creating and writing to smc
   
   { char buffer[64]="DELETE ME iam a Test...      ";  
     smc_write("dev0:\\delete.me",(char*)buffer,25);
   
     // Creating a Directory
     smc_createdir("dev0:\\DEL_ME");
   }   



while (1) { if ( gp_getButton()&BUTTON_A) gp_Reset();  }
}
