#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "gp32.h"

#define W            240
#define H            320

extern const char _random[];
extern unsigned char modfile[];

unsigned char *buffy256;
unsigned int pal[256];

struct particle {
  int X0,Y0;
  int V0x,V0y;
  int power;
  int time;
  struct particle *next;
};

typedef struct particle particle;

particle * firstparticle;

void refresh();

int random_pos=0;
char random () {
     char ret;
     if (random_pos==4096) random_pos=0;
     ret = _random[random_pos];
return ret;
}


u16 *framebuffer;

int main () {


   int val,i,x;
   
   framebuffer = (u16*) FRAMEBUFFER;
   gp_setCpuspeed(156);
   gp_startSoundmixer(1);
   gp_startModfile(modfile);
   
   gp_initFramebuffer(framebuffer,16,85);
   for (x=0;x<320*240;x++) *(framebuffer+x) =0xFFF0; // Clear Screen
   

  
  for ( i=0 ; i<256 ; i++ ) {  
    
    int r,g,b;

    r = g = b = 0 ;
    
    if ( (i > 7) && (i < 32) )
      r = 10 * ( i - 7 );
    if ( i > 31 )
      r = 255;
      
    if ( (i > 32 ) && (i < 57 ) )
      g = 10 * ( i - 32 );
    if ( i > 56 )
      g = 255;
    
    if ( i < 8 )
      b = 8 * i;
    if ( (i > 7) && (i < 17) )
      b = 8 * ( 16 - i );
    if ( (i > 57) && (i < 82) )
      b = 10 * ( i - 57 );
    if ( i > 81 )
      b = 255;

    pal[i] = (r<<16) + (g<<8) + (b);

  }

buffy256 = (unsigned char *) calloc ( W*H , 1 );

  firstparticle = NULL;

  while ( 1 ) {    
    refresh();
  }

}

void refresh() {
  
  /* B G R X */

  static double k=0;
  int i;

  unsigned char * buffy256_tmp = buffy256;
  unsigned char * blur = buffy256;

  particle * precurrentparticle;
  particle * currentparticle;

  /* Add new particles */

  for (i=0; i<16; i++) {

    int ii;

    for (ii=0; ii<16; ii++) {
      
      precurrentparticle = (particle *) malloc (sizeof(particle));
      
      precurrentparticle->V0x = random() - 16;
      precurrentparticle->V0y = random();
      
      precurrentparticle->X0 = W/2+
        W/2.5*
        sin((20*sin(k/20))+i*70)*
        (sin(10+k/(10+i))+0.2)*
        cos((k+i*25)/10);
      precurrentparticle->Y0 = H/2+
        H/2.5*
        cos((20*sin(k/(20+i)))+i*70)*
        (sin(10+k/10)+0.2)*
        cos((k+i*25)/10);
      
      precurrentparticle->power = 110+50*sin(k/3);
      precurrentparticle->time = 0;
      precurrentparticle->next = firstparticle;
      
      firstparticle = precurrentparticle;
      
    }
    
    k += 0.01;
    //  k += 0.04;
  }
  
  /*
   *  Physics:
   *
   *  Vx(t) = V0x
   *  Vy(t) = V0y - G.t
   *
   *  X(t) = X0 + V0x.t
   *  Y(t) = Y0 + V0y.t - G.t^2
   *
   */

  currentparticle = firstparticle->next;
  
  while (currentparticle != NULL) {
   
    int dawa;
    int tx,ty;
    int time;

    time = currentparticle->time / 16;
    // time = currentparticle->time / 64;


    tx =
      (currentparticle->X0) +
      time*(currentparticle->V0x);
    ty =
      (currentparticle->Y0) +
      time*(currentparticle->V0y) -
      time*time*2;
    
    ty = H-ty;

    if ((tx<W) && (ty>3) && (ty<H)) {
      dawa = buffy256 [ty*W+tx];
      dawa += currentparticle->power;
      if (dawa>255)
        dawa = 255;
      buffy256 [ty*W+tx] = dawa;
    }
    
    currentparticle->time += 1;

    currentparticle->power -= ((currentparticle->power >> 4) + 1);

    if (currentparticle->power <= 1) {
      precurrentparticle->next = currentparticle->next;
      free (currentparticle);
    } else
      precurrentparticle = currentparticle;
    
    currentparticle = precurrentparticle->next;

  }  

  /*
   * Blur :
   *
   *  &&&
   *  &@&
   *   &
   */

  blur += 2*W;
  
  for (i=0; i<W*(H-3); i++)
    * (blur++) =
        ( * (blur-W-1)     +
          * (blur-W)       +
          * (blur-W+1)     +
          * (blur-1)       +
          * (blur)         +
          ( (*blur) >> 1 ) +
          ( (*blur) >> 2 ) +
          * (blur+1)       +
          * (blur+W) ) >> 3;

  /* 24bpp conv */
 {    short * buffy_tmp = (short *) framebuffer;
      for ( i=0 ; i<W*(H) ; i++ )
      *(buffy_tmp++) = (pal [(short) *(buffy256_tmp++)]) ;
 // int xx;
 // for (xx=0;xx<H*W;xx++) framebuffer[xx]=0xff2+buffy256[xx];
  

 }

}

