// written 2004 Mirko Roller   mirko@mirkoroller.de

#include "gp32.h"

extern unsigned char modfile1[];
extern unsigned char modfile2[];
extern unsigned char sample1[];  // 22050 Stereo
extern unsigned char sample2[];  // 22050 Stereo
extern unsigned char sample3[];  // 22050 Mono


int main() {
  u16* framebuffer = (u16*) FRAMEBUFFER;
  // If you get clicky sound, disable cache on framebuffer
  gp_setMMU ( (u32)framebuffer,(u32)framebuffer+(320*240*2)-1, 0xFF2 );

  gp_setCpuspeed(33);
  gp_initFramebuffer(framebuffer,16,85);
  // gp_startModfile(modfile2);
  gp_startSoundmixer(0); // start Soundmixer

   gp_clearFramebuffer16 ( framebuffer, 0xFFFF );
   gp_drawString ( 20, 10, 35,"Mr.Mirko Mod/Mixer running @33Mhz   ", 0xF800, framebuffer );
   gp_drawString ( 20, 30, 25,"L     = Play Sample1       ", 0xF800, framebuffer );
   gp_drawString ( 20, 40, 25,"R     = Play Sample2       ", 0xF800, framebuffer );
   gp_drawString ( 20, 50, 25,"DOWN  = Play Sample3       ", 0xF800, framebuffer );
   gp_drawString ( 20, 60, 25,"START = Start Modfile1     ", 0xF800, framebuffer );
   gp_drawString ( 20, 70, 25,"SELECT= Start Modfile2     ", 0xF800, framebuffer );
   gp_drawString ( 20, 80, 25,"A     = RESET              ", 0xF800, framebuffer );
   gp_drawString ( 20, 90, 25,"B     = Stop  Soundmixer   ", 0xF800, framebuffer );
   gp_drawString ( 20,100, 25,"UP    = Start Soundmixer   ", 0xF800, framebuffer );

  while (1) {
    if (gp_getButton()&BUTTON_A)      gp_Reset();
    if (gp_getButton()&BUTTON_START)  gp_startModfile(modfile1);
    if (gp_getButton()&BUTTON_B)      gp_stopSoundmixer();
    if (gp_getButton()&BUTTON_SELECT) gp_startModfile(modfile2);
    if (gp_getButton()&BUTTON_L)      gp_addSample( (u16*)sample1,22050, 1, 0,100800);
    if (gp_getButton()&BUTTON_R)      gp_addSample( (u16*)sample2,22050, 1, 0,148160); 
    if (gp_getButton()&BUTTON_DOWN)   gp_addSample( (u16*)sample3,22050, 0, 0, 74080);
    if (gp_getButton()&BUTTON_UP)     gp_startSoundmixer(0);
  }

}

