// This file is written/copyright Mirko Roller

#include "gp32.h"


extern unsigned char font1[];
extern unsigned char font2[];
u16 *framebuffer;


int main() {
   int i;
   framebuffer =(u16*) FRAMEBUFFER;
   gp_setCpuspeed(22);
   gp_initFramebuffer(framebuffer,16,85);
   gp_clearFramebuffer16 (framebuffer ,0xFFFF);

   // This demo demonstrates how to set a tiled element to screen.
   // We use a nice Font to demonstrate it.
   // font1 is a 32x32 pixel tiled font
   // font2 is a 16x16 pixel tiled font
   // Have a look to the font.bmp, to understand the tiled format.
   // The format of the tiled bmp is:
   // _____________________
   // | A | B | C | D | E | ...
   // ---------------------
   
   // Display font1, char "A"
   gp_drawTiled16( (u16*)font1, 0x0000, 32, 0, 10   , 200, framebuffer);
   // Display font1, char "B"
   gp_drawTiled16( (u16*)font1, 0x0000, 32, 1, 10+32, 200, framebuffer);
   
   //Display font2, char "A"
   gp_drawTiled16( (u16*)font2, 0x0000, 16, 0, 100, 200, framebuffer);
   //Display font2, char "B"
   gp_drawTiled16( (u16*)font2, 0x0000, 16, 1, 100+16 , 200, framebuffer);
  
   
   // Display complete font2
   for (i=0;i<40;i++) gp_drawTiled16( (u16*)font2, 0x0000, 16, i, +0+(i*16)%320, ((i/20)*16), framebuffer);
   
   
   while (1) { }   
   
}
