//   converter, (c) 2004 Mirko Roller
//   Use it to convert Files, to C arrays.
// 
//   ./converter  picture.jpg >> picture.c

#include <stdio.h>          /*(perror)*/
#include <sys/mman.h>       /*PROT_READ,MAP_xxx*/
#include <fcntl.h>          /*O_RDONLY*/
#include <sys/stat.h>       /*stat*/
#include <stdlib.h>         /*(atoi)*/
#include <string.h>         /*strcmp*/

int main(int argc, char *argv[]) {
	FILE *inFile=stdin, *outFile=stdout;
	int a, i, nbCol=15;
	unsigned char *memory;
	char arrayName[255]="wasteland", *iFileName=NULL, *oFileName=NULL;
	struct stat st;

	// Is ther the good number of arguments
	if (argc<2)
	{
		fprintf(stderr, "Error: wrong number of arguments\n\tUsage: %s -a <arrayname> -n <bits per line> <inputfile> [outputfile] \n", argv[0]);
		return 0;
	}

	// On rcupre les arguments (Ready for more options)
	for (a=1; a<argc; a++)
	{
		// An option
		if (argv[a][0]=='-')
		{
			// Wich flag is it ?
			switch(argv[a][1])
			{
				// ArrayName flag
				case 'a':
					strcpy(arrayName, argv[++a]);
					break;

				// Number of bit per line
				case 'n':
					nbCol=atoi(argv[++a]);
					break;
			}
		}
		// A filename
		else
		{
			if (iFileName==NULL)
			{
				iFileName=argv[a];
				if ((inFile=fopen(iFileName, "rb"))==NULL)
				{
					fprintf(stderr, "Error: can't open %s\n", iFileName);
					return 0;
				}
			}
			else
			{
				if (oFileName==NULL)
				{
					oFileName=argv[a];
					if ((outFile=fopen(oFileName, "wb"))==NULL)
					{
						fprintf(stderr, "Error: can't open %s\n", oFileName);
						return 0;
					}
				}
				else
				{
					fprintf(stderr, "Error: Too many filesnames given!\n");
				}
			}
		}
	}

	if (!iFileName)
		return 0;

	// Get file informations
	if (stat(iFileName, &st)!=0)
	{
		fprintf(stderr, "Error: when scanning file %s\n", argv[1]);
		return 0;
	}

	// Allocating memory
	if (!(memory = malloc(st.st_size)))
	{
		fprintf(stderr, "Error: not enought memory\n");
		return 0;
	}

	// Reading the file
	if (fread(memory, 1, st.st_size, inFile)!=st.st_size)
	{
		fprintf(stderr, "Error: when reading file %s\n", argv[1]);
		fclose(inFile);
		return 0;
	}
	fclose(inFile);

	// Begin the array
	fprintf (outFile, "unsigned char %s[%u] = {\n\t", arrayName, (unsigned int)st.st_size);

	// Writing file elements
	for(i=0; i<st.st_size; i++)
	{
		// We write a byte
		fprintf (outFile, "0x%02X" ,memory[i]);

		// Must put a coma ?
		if (i!=st.st_size-1)
			fprintf(outFile, ", ");

		// End of a line ?
		if (i && !((i+1)%nbCol))
			fprintf(outFile, "\n\t");
	}

	// The last line as nbCol elements
	if (st.st_size%nbCol)
		fprintf(outFile, "\n");

	// Close the array
	fprintf(outFile, "};\n");

	// CLose the output file
	if (outFile!=stdout)
		fclose(outFile);

	// Free allocated memory
	free (memory);

	return 0;
}

